'use strict';

exports.__esModule = true;
exports.Code = exports.Strong = exports.Em = exports.Image = exports.Link = exports.Quote = exports.OList = exports.UList = exports.Br = exports.P = exports.H = exports.MarkdownRender = undefined;

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _MarkdownConfig = require('./MarkdownConfig');

var _MarkdownConfig2 = _interopRequireDefault(_MarkdownConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MarkdownRender = function () {
	function MarkdownRender() {
		_classCallCheck(this, MarkdownRender);
	}

	MarkdownRender.init = function init() {
		_MarkdownConfig2.default.Renders = {
			h: H,
			p: P,
			br: Br,
			ul: UList,
			ol: OList,
			quote: Quote,
			link: Link,
			image: Image,
			em: Em,
			strong: Strong,
			code: Code
		};
	};

	return MarkdownRender;
}();

var H = (_temp = _class = function (_Component) {
	_inherits(H, _Component);

	function H() {
		_classCallCheck(this, H);

		return _possibleConstructorReturn(this, _Component.apply(this, arguments));
	}

	H.prototype.render = function render() {
		var level = this.props.level;
		return _react2.default.createElement('h' + level, null, this.props.children);
	};

	return H;
}(_react.Component), _class.defaultProps = {
	level: 1
}, _temp);

var P = function (_Component2) {
	_inherits(P, _Component2);

	function P() {
		_classCallCheck(this, P);

		return _possibleConstructorReturn(this, _Component2.apply(this, arguments));
	}

	P.prototype.render = function render() {
		return _react2.default.createElement(
			'p',
			null,
			this.props.children
		);
	};

	return P;
}(_react.Component);

var Br = function (_Component3) {
	_inherits(Br, _Component3);

	function Br() {
		_classCallCheck(this, Br);

		return _possibleConstructorReturn(this, _Component3.apply(this, arguments));
	}

	Br.prototype.render = function render() {
		return _react2.default.createElement('br', null);
	};

	return Br;
}(_react.Component);

var UList = function (_Component4) {
	_inherits(UList, _Component4);

	function UList() {
		_classCallCheck(this, UList);

		return _possibleConstructorReturn(this, _Component4.apply(this, arguments));
	}

	UList.prototype.render = function render() {
		var list = this.props.list;
		return _react2.default.createElement(
			'ul',
			null,
			list.map(function (it) {
				return _react2.default.createElement(
					'li',
					null,
					it
				);
			})
		);
	};

	return UList;
}(_react.Component);

var OList = function (_Component5) {
	_inherits(OList, _Component5);

	function OList() {
		_classCallCheck(this, OList);

		return _possibleConstructorReturn(this, _Component5.apply(this, arguments));
	}

	OList.prototype.render = function render() {
		var list = this.props.list;
		return _react2.default.createElement(
			'ol',
			null,
			list.map(function (it) {
				return _react2.default.createElement(
					'li',
					null,
					it
				);
			})
		);
	};

	return OList;
}(_react.Component);

var Quote = function (_Component6) {
	_inherits(Quote, _Component6);

	function Quote() {
		_classCallCheck(this, Quote);

		return _possibleConstructorReturn(this, _Component6.apply(this, arguments));
	}

	Quote.prototype.render = function render() {
		return _react2.default.createElement(
			'blockquote',
			null,
			this.props.children
		);
	};

	return Quote;
}(_react.Component);

var Link = function (_Component7) {
	_inherits(Link, _Component7);

	function Link() {
		_classCallCheck(this, Link);

		return _possibleConstructorReturn(this, _Component7.apply(this, arguments));
	}

	Link.prototype.render = function render() {
		return _react2.default.createElement(
			'a',
			{ href: this.props.to, title: this.props.title },
			this.props.children
		);
	};

	return Link;
}(_react.Component);

var Image = function (_Component8) {
	_inherits(Image, _Component8);

	function Image() {
		_classCallCheck(this, Image);

		return _possibleConstructorReturn(this, _Component8.apply(this, arguments));
	}

	Image.prototype.render = function render() {
		return _react2.default.createElement('img', { src: this.props.src, alt: this.props.alt });
	};

	return Image;
}(_react.Component);

var Em = function (_Component9) {
	_inherits(Em, _Component9);

	function Em() {
		_classCallCheck(this, Em);

		return _possibleConstructorReturn(this, _Component9.apply(this, arguments));
	}

	Em.prototype.render = function render() {
		return _react2.default.createElement(
			'em',
			null,
			this.props.children
		);
	};

	return Em;
}(_react.Component);

var Strong = function (_Component10) {
	_inherits(Strong, _Component10);

	function Strong() {
		_classCallCheck(this, Strong);

		return _possibleConstructorReturn(this, _Component10.apply(this, arguments));
	}

	Strong.prototype.render = function render() {
		return _react2.default.createElement(
			'strong',
			null,
			this.props.children
		);
	};

	return Strong;
}(_react.Component);

var Code = function (_Component11) {
	_inherits(Code, _Component11);

	function Code() {
		_classCallCheck(this, Code);

		return _possibleConstructorReturn(this, _Component11.apply(this, arguments));
	}

	Code.prototype.render = function render() {
		return _react2.default.createElement(
			'code',
			null,
			this.props.children
		);
	};

	return Code;
}(_react.Component);

exports.MarkdownRender = MarkdownRender;
exports.H = H;
exports.P = P;
exports.Br = Br;
exports.UList = UList;
exports.OList = OList;
exports.Quote = Quote;
exports.Link = Link;
exports.Image = Image;
exports.Em = Em;
exports.Strong = Strong;
exports.Code = Code;